VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "SHDOCVW.DLL"
Begin VB.Form frmCopy 
   Caption         =   "Web Page Capture"
   ClientHeight    =   4845
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7125
   LinkTopic       =   "frmCopy"
   MinButton       =   0   'False
   ScaleHeight     =   4845
   ScaleWidth      =   7125
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picPicture 
      Height          =   252
      Left            =   6120
      ScaleHeight     =   195
      ScaleWidth      =   555
      TabIndex        =   2
      Top             =   120
      Width           =   612
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Height          =   252
      Left            =   120
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   120
      Width           =   972
   End
   Begin SHDocVwCtl.WebBrowser brwBrowser 
      Height          =   4092
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   6852
      ExtentX         =   12086
      ExtentY         =   7218
      ViewMode        =   1
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   -1  'True
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   "http:///"
   End
End
Attribute VB_Name = "frmCopy"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
    
'
'  Copy a Web Page to the Clipboard
'
'  Copyright James Miller - 2005
'
'  Web Site - http://www.daisy.co.uk
'  E-Mail - james@daisy.co.uk
'
'  Note that the CaptureWindow and CreateBitmapPicture routines are from the Microsoft KB
'  Article Q161299.  Comments have been removed but the code is exactly as in the article.
    
    Public FormMargin As Long
    Public SizableWidth As Long
    Public CaptionHeight As Long

    Private Const RASTERCAPS = 38        '  Bitblt capabilities
    Private Const RC_PALETTE = &H100                 '  supports a palette
    Private Const SIZEPALETTE = 104      '  Number of entries in physical palette

    Private Const SM_CYCAPTION = 4
    Private Const SM_CXFRAME = 32
    Private Const SM_CXSIZEFRAME = SM_CXFRAME

    Private Type PALETTEENTRY
        peRed As Byte
        peGreen As Byte
        peBlue As Byte
        peFlags As Byte
    End Type
    Private Type LOGPALETTE
        palVersion As Integer
        palNumEntries As Integer
        palPalEntry(1) As PALETTEENTRY
    End Type
    Private Type GUID
        Data1 As Long
        Data2 As Integer
        Data3 As Integer
        Data4(7) As Byte
    End Type
    Private Type PicBmp
        Size As Long
        Type As Long
        hBmp As Long
        hPal As Long
        Reserved As Long
    End Type

    Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, _
        ByVal ySrc As Long, ByVal dwRop As Long) As Long
    Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, _
        ByVal nHeight As Long) As Long
    Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
    Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
    Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
    Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
    Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
    Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
    Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
    Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, _
        ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
    Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, _
        RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPictureDisp) As Long
    Private Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
    Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
    Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
    Private Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal _
        bForceBackground As Long) As Long

Private Function CaptureWindow(ByVal hWndSrc As Long, ByVal Client As Boolean, ByVal LeftSrc As Long, _
        ByVal TopSrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long) As Picture
'
'  Copyright Microsoft - Q161299
    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim HBmpPrev As Long
    Dim r As Long
    Dim hDCSrc As Long
    Dim hPal As Long
    Dim hPalPrev As Long
    Dim RasterCapsScrn As Long
    Dim HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long
    Dim LogPal As LOGPALETTE
    On Error Resume Next
    If (Client = True) Then
        hDCSrc = GetDC(hWndSrc)
    Else
        hDCSrc = GetWindowDC(hWndSrc)
    End If
    hDCMemory = CreateCompatibleDC(hDCSrc)
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    HBmpPrev = SelectObject(hDCMemory, hBmp)
    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS)
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE)
    If (HasPaletteScrn <> 0 And PaletteSizeScrn = 256) Then
        LogPal.palVersion = &H300
        LogPal.palNumEntries = 256
        r = GetSystemPaletteEntries(hDCSrc, 0, 256, LogPal.palPalEntry(0))
        hPal = CreatePalette(LogPal)
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        r = RealizePalette(hDCMemory)
    End If
    r = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, LeftSrc, TopSrc, vbSrcCopy)
    hBmp = SelectObject(hDCMemory, HBmpPrev)
    If (HasPaletteScrn <> 0 And PaletteSizeScrn = 256) Then
        hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If
    r = DeleteDC(hDCMemory)
    r = ReleaseDC(hWndSrc, hDCSrc)
    Set CaptureWindow = CreateBitmapPicture(hBmp, hPal)
End Function

Private Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture
'
'  Copyright Microsoft - Q161299
    Dim r As Long
    Dim Pic As PicBmp
    Dim IPic As IPicture
    Dim IID_IDispatch As GUID
    On Error Resume Next
    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
    With Pic
        .Size = Len(Pic)
        .Type = vbPicTypeBitmap
        .hBmp = hBmp
        .hPal = hPal
    End With
    r = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)
    Set CreateBitmapPicture = IPic
End Function

Private Sub cmdCopy_Click()
'
'  This Copies the Web Page to the Clipboard
    Dim wrkLeft As Long
    Dim wrkTop As Long
    Dim wrkWidth As Long
    Dim wrkHeight As Long
    On Error Resume Next
'
'  Get the Positions and Widths in Pixels
'
'  Get Left Position of Actual Web Page - Note the 2nd SizableWidth jumps the border
'  of the web page in the the Browser control
    wrkLeft = ScaleX(SizableWidth + brwBrowser.Left + SizableWidth, vbTwips, vbPixels)
'
'  Get Top Position of Actual Web Page - Note the 2nd SizableWidth
    wrkTop = ScaleY(SizableWidth + CaptionHeight + brwBrowser.Top + SizableWidth, vbTwips, vbPixels)
'
'  Get Width of Actual Web Page - Note the subtraction of 1 Pixel to account for right margin
    wrkWidth = ScaleX(brwBrowser.Width - SizableWidth, vbTwips, vbPixels) - 1
'
'  Get Height of Actual Web Page - Note the subtraction of 1 Pixel to account for bottom margin
    wrkHeight = ScaleY(brwBrowser.Height - SizableWidth, vbTwips, vbPixels) - 1
'
'  Capture the Selected Area to the Picture Box
    Set picPicture.Picture = CaptureWindow(hwnd, False, wrkLeft, wrkTop, wrkWidth, wrkHeight)
'
'  Copy the Picture to the Clipboard
    Clipboard.Clear
    Clipboard.SetData picPicture.Image
    brwBrowser.SetFocus
End Sub

Private Sub Form_Load()
    On Error Resume Next
    FormMargin = 60
    CaptionHeight = GetSystemMetrics(SM_CYCAPTION) * Screen.TwipsPerPixelY
    SizableWidth = GetSystemMetrics(SM_CXSIZEFRAME) * Screen.TwipsPerPixelY
    brwBrowser.Navigate "about:blank"
    picPicture.Visible = False
    picPicture.AutoSize = True
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    brwBrowser.Left = FormMargin
    brwBrowser.Width = ScaleWidth - 2 * FormMargin
    brwBrowser.Height = ScaleHeight - brwBrowser.Top - FormMargin
End Sub
